<!doctype html>
<html lang="en">
 <head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="generator" content="Asciidoctor 2.0.23">
  <meta name="author" content="Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation">
  <link rel="icon" type="image/png" href="../../favicon.png">
  <title>Lexical syntax | ToolDef documentation</title>
  <link rel="stylesheet" href="../../assets/asciidoctor-escet-tooldef.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <link rel="stylesheet" href="../../assets/styles/asciidoctor-highlightjs-escet.min.css"> <!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <meta name="robots" content="noindex">
  <script type="text/javascript" src="../../assets/asciidoctor-escet-tooldef.js"></script>
 </head>
 <body class="book toc2 toc-left" onload="onLoad()">
  <div id="header">
   <div id="toc" class="toc2">
    <p class="website-link">Part of: <a href="../..">ToolDef website</a></p>
    <div id="toctitle">
     ToolDef documentation
    </div>
    <ul class="sectlevel1">
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../../documentation.html">Home</a></li>
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../../introduction.html">Introduction</a></li>
     <li class="toc-cur-page-ancestor toc-item toc-item-parent expanded">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../index.html">Language reference</a>
      <ul class="sectlevel2">
       <li class="toc-cur-page-ancestor toc-item toc-item-parent expanded">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../index.html#syntax">Syntax</a>
        <ul class="sectlevel3">
         <li class="toc-cur-page toc-item toc-item-parent expanded">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="#">Lexical syntax</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#keywords">Keywords</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#terminals">Terminals</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#whitespace">Whitespace</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#comments">Comments</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="grammar.html">Grammar</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../index.html#built-in-tools-and-operators">Built-in tools and operators</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../builtins/operators.html">Built-in operators</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/operators.html#not-operator">not operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/operators.html#and-operator">and operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/operators.html#or-operator">or operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/operators.html#operator-unary1">+ operator (unary)</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/operators.html#operator-binary1">+ operator (binary)</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/operators.html#operator-unary2">- operator (unary)</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/operators.html#operator-binary2">- operator (binary)</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/operators.html#operator1">* operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/operators.html#operator2">/ operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/operators.html#div-operator">div operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/operators.html#mod-operator">mod operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/operators.html#operator3">&lt; operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/operators.html#operator4">&lt;= operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/operators.html#operator5">&gt; operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/operators.html#operator6">&gt;= operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/operators.html#operator7">== operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/operators.html#operator8">!= operator</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../builtins/data.html">Built-in data tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#abs-tool">abs tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#ceil-tool">ceil tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#contains-tool">contains tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#del-tool">del tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#delidx-tool">delidx tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#empty-tool">empty tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#endswith-tool">endswith tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#entries-tool">entries tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#enumerate-tool">enumerate tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#floor-tool">floor tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#fmt-tool">fmt tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#indexof-tool">indexof tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#join-tool">join tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#keys-tool">keys tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#lastindexof-tool">lastindexof tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#ln-tool">ln tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#log-tool">log tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#lower-tool">lower tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#ltrim-tool">ltrim tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#max-tool">max tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#min-tool">min tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#pow-tool">pow tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#range-tool">range tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#replace-tool">replace tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#reverse-tool">reverse tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#round-tool">round tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#rtrim-tool">rtrim tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#size-tool">size tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#sorted-tool">sorted tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#split-tool">split tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#sqrt-tool">sqrt tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#startswith-tool">startswith tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#str-tool">str tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#strdup-tool">strdup tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#subset-tool">subset tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#trim-tool">trim tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#upper-tool">upper tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/data.html#values-tool">values tool</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../builtins/io.html">Built-in I/O tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/io.html#out-tool">out tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/io.html#err-tool">err tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/io.html#outln-tool">outln tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/io.html#errln-tool">errln tool</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../builtins/generic.html">Built-in generic tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/generic.html#app-tool">app tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/generic.html#exec-tool">exec tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/generic.html#tooldef-tool">tooldef tool</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../builtins/path.html">Built-in path tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/path.html#abspath-tool">abspath tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/path.html#basename-tool">basename tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/path.html#chdir-tool">chdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/path.html#chfileext-tool">chfileext tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/path.html#curdir-tool">curdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/path.html#dirname-tool">dirname tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/path.html#fileext-tool">fileext tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/path.html#hasfileext-tool">hasfileext tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/path.html#pathjoin-tool">pathjoin tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/path.html#scriptpath-tool">scriptpath tool</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../builtins/file.html">Built-in file tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/file.html#cpfile-tool">cpfile tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/file.html#cpdir-tool">cpdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/file.html#diff-tool">diff tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/file.html#exists-tool">exists tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/file.html#filenewer-tool">filenewer tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/file.html#filesize-tool">filesize tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/file.html#find-tool">find tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/file.html#isdir-tool">isdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/file.html#isfile-tool">isfile tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/file.html#mkdir-tool">mkdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/file.html#mvfile-tool">mvfile tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/file.html#mvdir-tool">mvdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/file.html#readlines-tool">readlines tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/file.html#rmfile-tool">rmfile tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/file.html#rmdir-tool">rmdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../builtins/file.html#writefile-tool">writefile tool</a></li>
          </ul></li>
        </ul></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../../interpreter.html">ToolDef interpreter</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../interpreter.html#command-line">Command line</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../interpreter.html#escet-ide">ESCET IDE</a></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../../release-notes.html">ToolDef release notes</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-5-0-2024-10-03">Version 5.0 (2024-10-03)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-4-0-2024-06-30">Version 4.0 (2024-06-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-3-0-2024-03-31">Version 3.0 (2024-03-31)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-2-0-2023-12-22">Version 2.0 (2023-12-22)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-1-0-2023-09-30">Version 1.0 (2023-09-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-10-2023-06-30">Version 0.10 (2023-06-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-9-2023-03-31">Version 0.9 (2023-03-31)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-8-2022-12-21">Version 0.8 (2022-12-21)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-7-2022-09-30">Version 0.7 (2022-09-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-6-2022-07-07">Version 0.6 (2022-07-07)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-5-2022-03-29">Version 0.5 (2022-03-29)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-4-2021-12-17">Version 0.4 (2021-12-17)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-3-2021-10-01">Version 0.3 (2021-10-01)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-2-2021-07-07">Version 0.2 (2021-07-07)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-1-2021-04-02">Version 0.1 (2021-04-02)</a></li>
      </ul></li>
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../../documentation-legal.html">Legal</a></li>
    </ul>
   </div>
  </div>
  <div id="content">
   <div id="breadcrumbs">
    <a class="breadcrumb" href="../../documentation.html">ToolDef documentation</a> &gt; <a class="breadcrumb" href="../index.html">Language reference</a> &gt; <a class="breadcrumb" href="../index.html#syntax">Syntax</a> &gt; <span class="breadcrumb">Lexical syntax</span>
   </div>
   <h2 id="lexical-syntax"><a class="anchor" href="#"></a>Lexical syntax</h2>
   <div class="paragraph">
    <p>This page describes the ToolDef lexical syntax.</p>
   </div>
   <div class="sect4">
    <h3 id="keywords"><a class="anchor" href="#keywords"></a>Keywords</h3>
    <div class="paragraph">
     <p><em>General</em></p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">as          else        if          map         tool
bool        end         import      null        true
break       exit        in          object      tuple
continue    false       int         return      type
double      for         list        set         while
elif        from        long        string</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p><em>Operators</em></p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">and         div         mod         not         or</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p><em>Built-in data tools</em></p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">abs         enumerate      log         reverse       str
ceil        floor          lower       round         strdup
contains    fmt            ltrim       rtrim         subset
del         indexof        max         size          trim
delidx      join           min         sorted        upper
empty       keys           pow         split         values
endswith    lastindexof    range       sqrt
entries     ln             replace     startswith</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p><em>Built-in I/O tools</em></p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">err         errln       out         outln</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p><em>Built-in generic tools</em></p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">app         exec        tooldef</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p><em>Built-in path tools</em></p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">abspath     dirname
basename    fileext
chdir       hasfileext
chfileext   pathjoin
curdir      scriptpath</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p><em>Built-in file tools</em></p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">cpdir       filenewer   isfile      readlines
cpfile      filesize    mkdir       rmdir
diff        find        mvdir       rmfile
exists      isdir       mvfile      writefile</code></pre>
     </div>
    </div>
   </div>
   <div class="sect4">
    <h3 id="terminals"><a class="anchor" href="#terminals"></a>Terminals</h3>
    <div class="paragraph">
     <p>Besides the keyword terminals listed above, ToolDef features several other terminals:</p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>IDENTIFIERTK</code>
      </dt>
      <dd>
       <p>An identifier. Defined by the regular expression: <code>[$]?[a-zA-Z_][a-zA-Z0-9_]*</code>. They thus consist of letters, numbers and underscore characters (<code>_</code>). Identifiers may not start with a numeric digit. Keywords take priority over identifiers. To use a keyword as an identifier, prefix it with a <code>$</code> character. The <code>$</code> is not part of the identifier name.</p>
       <div class="paragraph">
        <p>Examples:</p>
       </div>
       <div class="listingblock">
        <div class="content">
         <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">apple       // identifier
bear        // identifier
int         // keyword
$int        // identifier 'int' (override keyword priority with $)</code></pre>
        </div>
       </div>
      </dd>
     </dl>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>RELATIVENAMETK</code>
      </dt>
      <dd>
       <p>A name. Defined by the regular expression: <code>[$]?[a-zA-Z_][a-zA-Z0-9_]*(\.[$]?[a-zA-Z_][a-zA-Z0-9_]*)+</code>. It thus consists of two or more <code>IDENTIFIERTK</code> joined together with periods (<code>.</code>).</p>
       <div class="paragraph">
        <p>Examples:</p>
       </div>
       <div class="listingblock">
        <div class="content">
         <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">some_library.some_tool</code></pre>
        </div>
       </div>
      </dd>
     </dl>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>NUMBERTK</code>
      </dt>
      <dd>
       <p>An integer literal. Defined by the regular expression: <code>0|[1-9][0-9]*</code>. Integers thus consist of numeric digits. Only for the number <code>0</code> may an integer literal start with <code>0</code>. E.g. <code>02</code> is invalid.</p>
       <div class="paragraph">
        <p>Examples:</p>
       </div>
       <div class="listingblock">
        <div class="content">
         <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">0
1
123</code></pre>
        </div>
       </div>
      </dd>
     </dl>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>DOUBLETK</code>
      </dt>
      <dd>
       <p>A double literal. Defined by the regular expression: <code>(0|[1-9][0-9]*)(\.[0-9]+|(\.[0-9]+)?[eE][\-\+]?[0-9]+)</code>. Simple double literals consist of an integer literal followed by a period (<code>.</code>) and some numeric digits. Double literals using scientific notation start with either an integer literal or a simple double literal. They then contain either an <code>e</code> or <code>E</code>, followed by the exponent. The exponent consists of numeric digits, optionally preceded by <code>+</code> or <code>-</code>.</p>
       <div class="paragraph">
        <p>Examples:</p>
       </div>
       <div class="listingblock">
        <div class="content">
         <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">0.0
1e5
1E+03
1.05e-78</code></pre>
        </div>
       </div>
      </dd>
     </dl>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>STRINGTK</code>
      </dt>
      <dd>
       <p>A string literal. Defined by the regular expression: <code>\"([^\\\"\n]|\\[nt\\\"])*\"</code>. String literals are enclosed in double quotes (<code>"</code>). String literals must be on a single line and must thus not include new line characters (<code>\n</code>, Unicode U+0A). To include a double quote (<code>"</code>) in a string literal, it must be escaped as <code>\"</code>. Since a backslash (<code>\</code>) serves as escape character, to include a backslash in a string literal it must be escaped as <code>\\</code>. To include a tab character in a string literal, use <code>\t</code>. To include a newline in a string literal, use <code>\n</code>.</p>
       <div class="paragraph">
        <p>Examples:</p>
       </div>
       <div class="listingblock">
        <div class="content">
         <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">"hello world"
"first line\nsecond line"</code></pre>
        </div>
       </div>
      </dd>
     </dl>
    </div>
   </div>
   <div class="sect4">
    <h3 id="whitespace"><a class="anchor" href="#whitespace"></a>Whitespace</h3>
    <div class="paragraph">
     <p>ToolDef supports spaces, tabs, and new line characters as whitespace. Whitespace is ignored (except in string literals), but can be used to separate tokens as well as for layout purposes. The use of tab characters is allowed, but should be avoided if possible, as layout will be different for text editors with different tab settings. You may generally format a ToolDef script as you see fit, and start on a new line when desired.</p>
    </div>
    <div class="paragraph">
     <p>Examples:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">// Normal layout.
int x = 5;

// Alternative layout.
int
  x    =
    5
  ;</code></pre>
     </div>
    </div>
   </div>
   <div class="sect4">
    <h3 id="comments"><a class="anchor" href="#comments"></a>Comments</h3>
    <div class="paragraph">
     <p>ToolDef features two types of comments. Single line comments start with <code>//</code> and end at end of the line. Multi line comments start with <code>/*</code> and end at <code>*/</code>. Comments are ignored.</p>
    </div>
    <div class="paragraph">
     <p>Examples:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">int x = 5; // Single line comment.

int /* some comment */ x = /* some
  more comments
  and some more
 end of the multi line comment */ 5;</code></pre>
     </div>
    </div>
   </div>
  </div>
  <script src="../../assets/highlight.min.js"></script>
  <script src="../../assets/languages/asciidoc.min.js"></script>
  <script src="../../assets/languages/bash.min.js"></script>
  <script src="../../assets/languages/bnf.min.js"></script>
  <script src="../../assets/languages/c.min.js"></script>
  <script src="../../assets/languages/chi.min.js"></script>
  <script src="../../assets/languages/cif.min.js"></script>
  <script src="../../assets/languages/console.min.js"></script>
  <script src="../../assets/languages/css.min.js"></script>
  <script src="../../assets/languages/dsm.min.js"></script>
  <script src="../../assets/languages/java.min.js"></script>
  <script src="../../assets/languages/javascript.min.js"></script>
  <script src="../../assets/languages/markdown.min.js"></script>
  <script src="../../assets/languages/mcrl2.min.js"></script>
  <script src="../../assets/languages/none.min.js"></script>
  <script src="../../assets/languages/plcst.min.js"></script>
  <script src="../../assets/languages/properties.min.js"></script>
  <script src="../../assets/languages/raildiagram.min.js"></script>
  <script src="../../assets/languages/setext.min.js"></script>
  <script src="../../assets/languages/shell.min.js"></script>
  <script src="../../assets/languages/tooldef.min.js"></script>
  <script src="../../assets/languages/xml.min.js"></script>
  <script>
if (!hljs.initHighlighting.called) {
  hljs.initHighlighting.called = true
  ;[].slice.call(document.querySelectorAll('pre.highlight > code[data-lang]')).forEach(function (el) { hljs.highlightElement(el) })
}
</script>
  <script type="text/x-mathjax-config">
MathJax.Hub.Config({
  messageStyle: "none",
  tex2jax: {
    inlineMath: [["\\(", "\\)"]],
    displayMath: [["\\[", "\\]"]],
    ignoreClass: "nostem|nolatexmath"
  },
  asciimath2jax: {
    delimiters: [["\\$", "\\$"]],
    ignoreClass: "nostem|noasciimath"
  },
  TeX: { equationNumbers: { autoNumber: "none" } }
})
MathJax.Hub.Register.StartupHook("AsciiMath Jax Ready", function () {
  MathJax.InputJax.AsciiMath.postfilterHooks.Add(function (data, node) {
    if ((node = data.script.parentNode) && (node = node.parentNode) && node.classList.contains("stemblock")) {
      data.math.root.display = "block"
    }
    return data
  })
})
</script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.9/MathJax.js?config=TeX-MML-AM_HTMLorMML"></script> <!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <div id="footer">
   <div id="footer-text">
    <span>ToolDef documentation</span> | <span>Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation</span> | <span>version v5.0</span><br> <a href="https://www.eclipse.org">Eclipse Home</a> | <a href="https://www.eclipse.org/legal/privacy.php">Privacy Policy</a> | <a href="https://www.eclipse.org/legal/termsofuse.php">Terms of Use</a> | <a href="https://www.eclipse.org/legal/copyright.php">Copyright Agent</a> | <a href="https://www.eclipse.org/legal">Eclipse Legal</a>
   </div>
  </div>
 </body>
</html>